// $Id: NodeView.java,v 1.18 2000/11/19 07:34:12 kmbarber Exp $


class NodeView
    extends javax.swing.JFrame
{
    javax.swing.JTable table;
    Node node;
    java.util.Vector nvVector;

    /**
     * display the Statements involving a given Node
     */
    NodeView(Node node)
    {
	super("DAML Viewer - Node: " + node.value);

	this.node = node;

	nvVector = new java.util.Vector();
	
	javax.swing.JPanel panel;
	javax.swing.JScrollPane sp;
	
	java.util.Iterator iterator;
	final java.util.Vector vector = new java.util.Vector();

	iterator = node.subjects.iterator();
	while (iterator.hasNext())
	    {
		Statement statement = (Statement) iterator.next();
		java.util.Vector valueVector = new java.util.Vector();
		valueVector.add(statement.property.getShortName());
		valueVector.add("-->");
		valueVector.add(statement.object);
		vector.add(valueVector);
	    }
	iterator = node.objects.iterator();
	while (iterator.hasNext())
	    {
		Statement statement = (Statement) iterator.next();
		java.util.Vector valueVector = new java.util.Vector();
		valueVector.add(statement.property.getShortName());
		valueVector.add("<--");
		valueVector.add(statement.subject);
		vector.add(valueVector);
	    }
	java.util.Vector columnNames = new java.util.Vector();
	columnNames.add("Property");
	columnNames.add("");
	columnNames.add("Value");
	table = new javax.swing.JTable(vector, columnNames);
	
	// parse table looking for resources ... indicate you can select them
	// java.util.Iterator vIt = vector.iterator();
	// while (vIt.hasNext())
	//    {
	// 	Node n = (Node) ((java.util.Vector) vector.elementAt(row)).elementAt(col);
	//	//if ((n != null)
	//	//  && (n instanceof Resource))
	//	    // make this look different somehow...not sure how
	//    }
	
	table.setPreferredScrollableViewportSize(new java.awt.Dimension(800, 50));
	table.getColumn("Property").setMaxWidth(150);
	table.getColumn("").setMaxWidth(20);

	// right-align Property column
	javax.swing.table.DefaultTableCellRenderer right = new javax.swing.table.DefaultTableCellRenderer();
	right.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
	table.getColumn("Property").setCellRenderer(right);
	
	table.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
	javax.swing.ListSelectionModel rowSM = table.getSelectionModel();
	rowSM.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
	    public void valueChanged(javax.swing.event.ListSelectionEvent e)
		{
		    //Ignore extra messages.
		    if (e.getValueIsAdjusting()) return;
		
		    javax.swing.ListSelectionModel lsm = (javax.swing.ListSelectionModel) e.getSource();
		    if (lsm.isSelectionEmpty())
			{
			    //no rows are selected
			}
		    else
			{
			    int row = table.getSelectedRow();
			    int col = table.getSelectedColumn();
			    Node node = null;
			    switch (col)
				{
				case 0:
				    // property
				    node = (Node) NodeView.this.node.getStatement(row).property;
				    break;
				    
				case 1:
				    // reification
				    Statement statement = NodeView.this.node.getStatement(row);
				    try {
					node = statement.viewer.getNode(statement.statement.getURI());
				    } catch (Exception ex) {
					System.out.println("reification:  " + ex);
				    }
				    break;
				    
				case 2:
				    // value
				    node = (Node) ((java.util.Vector) vector.elementAt(row)).elementAt(col);
				    break;

				default:
				    System.err.println("unexpected col " + col);
				}
			    if ((node != null)
				&& (node instanceof Resource))
				{
				    NodeView nv = new NodeView(node);
				    nvVector.add(nv);
				}
			}
		}
	});

	sp = new javax.swing.JScrollPane(table);
	panel = new javax.swing.JPanel();
	panel.setLayout(new java.awt.BorderLayout());
	panel.add(sp, java.awt.BorderLayout.CENTER);
	this.getContentPane().add(panel);
	int width = 800;
	int height = 200;
	java.awt.Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
	int x = (screen.width - width) / 2;
	int y = (screen.height - height) / 2;
	this.setBounds(x, y, width, height);
	this.setVisible(true);
    }
}
