// $Id: Statement.java,v 1.2 2000/11/10 23:42:04 mdean Exp $


/**
 * Viewer representation of a statement
 */
class Statement
{
    Viewer viewer;
    org.w3c.rdf.model.Statement statement;
    
    Node subject;
    Node property;
    Node object;

    /**
     * create Statement from RDF API Statement
     */
    Statement(Viewer viewer,
	      org.w3c.rdf.model.Statement statement)
	throws Exception
    {
	this.viewer = viewer;
	this.statement = statement;

	subject = viewer.getNode(statement.subject().getLabel());
	subject.subjects.addElement(this);

	property = viewer.getNode(statement.predicate().getLabel());
	property.properties.addElement(this);

	org.w3c.rdf.model.RDFNode obj = statement.object();
	if (obj instanceof org.w3c.rdf.model.Resource)
	    {
		object = viewer.getNode(obj.getLabel());
		object.objects.addElement(this);
	    }
	else if (obj instanceof org.w3c.rdf.model.Literal)
	    {
		object = new Literal(obj.getLabel());
	    }
	else
	    {
		System.err.println("unexpected type " + obj.getClass() + " for " + obj);
	    }
    }
}
